function Automated_lungseg

Iorig = imread('MR003001030.tif');
origx=60; origy=60; endx = 210; endy = 230;
I = double(bwareaopen(Iorig(origy:1:endy,origx:1:endx,1)>40,100));
[h,w,b]=size(I);

set(gcf,'doublebuffer','on');
figure(1), imagesc(Iorig), colormap(gray), truesize, axis('square','off'),drawnow;
[fx,fy] = gradient(I);
f = sqrt(fx.*fx + fy.*fy);
rads=3;
alfa = 0.1; beta =0.05;

[lcx,lcy,rcx,rcy]=assignsnakes(I,rads,80,80);
nlSnake=length(lcx);
nrSnake=length(rcx);
t = 0:0.05:6.28;
MaxSnaxel=200;
lx=zeros(nlSnake,MaxSnaxel);
ly=zeros(nlSnake,MaxSnaxel);
rx=zeros(nrSnake,MaxSnaxel);
ry=zeros(nrSnake,MaxSnaxel);

nlSnaxel=length(t)*ones(nlSnake,1);
nrSnaxel=length(t)*ones(nrSnake,1);

ux = []; uy = []; initx=[]; inity=[];
for numsnake=1:nlSnake,
    lx(numsnake,1:nlSnaxel(numsnake)) = lcx(numsnake) + rads*cos(t);
    ly(numsnake,1:nlSnaxel(numsnake)) = lcy(numsnake) + rads*sin(t);
    ux = [ux cos(t)]; uy = [uy sin(t)];
    initx = [initx lx(numsnake,1:nlSnaxel(numsnake))];
    inity = [inity ly(numsnake,1:nlSnaxel(numsnake))];
    snakedisp(lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1,'w');
end
for numsnake=1:nrSnake,
    rx(numsnake,1:nrSnaxel(numsnake)) = rcx(numsnake) + rads*cos(t);
    ry(numsnake,1:nrSnaxel(numsnake)) = rcy(numsnake) + rads*sin(t);
    ux = [ux cos(t)]; uy = [uy sin(t)];
    initx = [initx rx(numsnake,1:nrSnaxel(numsnake))];
    inity = [inity ry(numsnake,1:nrSnaxel(numsnake))];
    snakedisp(rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1,'w');
end

mask = I; mask(:) = 0;
ind  = h*(round(initx)-1)+round(inity); mask(ind) = 1;
se=strel('disk',1);
mask = imerode(bwfill(mask,'holes'),se);
disp(' Compute GGVF with normal diffusion ...');
[u,v] = GGVFperpbc(f,0.01,25,~mask,ux,uy,initx,inity);
mag = sqrt(u.*u+v.*v);
px = u./(mag+1e-10); py = v./(mag+1e-10);

% evolve the left snakes
for i=1:10,
    for numsnake=1:nlSnake,
        tempx = lx(numsnake,1:nlSnaxel(numsnake));
        tempy = ly(numsnake,1:nlSnaxel(numsnake));
        [tempx,tempy] = snakedeform(tempx',tempy',alfa,beta,1,0.6,px,py,5);
        [tempx,tempy] = snakeinterp(tempx,tempy,3,0.1);
        nlSnaxel(numsnake) = length(tempx);
        lx(numsnake,1:nlSnaxel(numsnake)) = tempx';
        ly(numsnake,1:nlSnaxel(numsnake)) = tempy';
        if rem(i,2)==0,
            snakedisp(lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1,'w');
            drawnow;
        end
    end
end
% evolve the right snakes
for i=1:10,
    for numsnake=1:nrSnake,
        tempx = rx(numsnake,1:nrSnaxel(numsnake));
        tempy = ry(numsnake,1:nrSnaxel(numsnake));
        [tempx,tempy] = snakedeform(tempx',tempy',alfa,beta,1,0.6,px,py,5);
        [tempx,tempy] = snakeinterp(tempx,tempy,3,0.1);
        nrSnaxel(numsnake) = length(tempx);
        rx(numsnake,1:nrSnaxel(numsnake)) = tempx';
        ry(numsnake,1:nrSnaxel(numsnake)) = tempy';
        if rem(i,2)==0,
            snakedisp(rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1,'w');
            drawnow;
        end
    end
end

figure(2), imagesc(Iorig), colormap(gray), truesize, axis('square','off'),drawnow;

for numsnake=1:nlSnake,
    snakedisp(lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1,'r');
end
for numsnake=1:nrSnake,
    snakedisp(rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1,'r');
end


% evolve the snakes for the second time with:
alfa = 0.01; beta =0.05;
% evolve the left snakes
for i=1:0,
    for numsnake=1:nlSnake,
        tempx = lx(numsnake,1:nlSnaxel(numsnake));
        tempy = ly(numsnake,1:nlSnaxel(numsnake));
        [tempx,tempy] = snakedeform(tempx',tempy',alfa,beta,1,0.6,px,py,5);
        [tempx,tempy] = snakeinterp(tempx,tempy,3,0.1);
        nlSnaxel(numsnake) = length(tempx);
        lx(numsnake,1:nlSnaxel(numsnake)) = tempx';
        ly(numsnake,1:nlSnaxel(numsnake)) = tempy';
        if rem(i,2)==0,
            snakedisp(lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1,'w');
            drawnow;
        end
    end
end
% evolve the right snakes
for i=1:0,
    for numsnake=1:nrSnake,
        tempx = rx(numsnake,1:nrSnaxel(numsnake));
        tempy = ry(numsnake,1:nrSnaxel(numsnake));
        [tempx,tempy] = snakedeform(tempx',tempy',alfa,beta,1,0.6,px,py,5);
        [tempx,tempy] = snakeinterp(tempx,tempy,3,0.1);
        nrSnaxel(numsnake) = length(tempx);
        rx(numsnake,1:nrSnaxel(numsnake)) = tempx';
        ry(numsnake,1:nrSnaxel(numsnake)) = tempy';
        if rem(i,2)==0,
            snakedisp(rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1,'w');
            drawnow;
        end
    end
end

figure(3), imagesc(Iorig), colormap(gray), truesize, axis('square','off'),drawnow;

for numsnake=1:nlSnake,
    snakedisp(lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1,'r');
end
for numsnake=1:nrSnake,
    snakedisp(rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1,'r');
end

segres = Iorig(:,:,1); segres(:)=0;
se = strel('disk',1);
for numsnake=1:nlSnake,
    [tmp,bw] = roifill(double(Iorig(:,:,1)),lx(numsnake,1:nlSnaxel(numsnake))+origx-1,ly(numsnake,1:nlSnaxel(numsnake))+origy-1);
    segres = or(segres,bw);
end
segres = imclose(imopen(bwfill(segres,'holes'),se),se);
edgind = find(bwperim(segres));

segres(:)=0;
se = strel('disk',1);
for numsnake=1:nrSnake,
    [tmp,bw] = roifill(double(Iorig(:,:,1)),rx(numsnake,1:nrSnaxel(numsnake))+origx-1,ry(numsnake,1:nrSnaxel(numsnake))+origy-1);
    segres = or(segres,bw);
end
segres = imclose(imopen(bwfill(segres,'holes'),se),se);
edgind = [edgind; find(bwperim(segres))];
Iorig(edgind)=255;

figure(4),imagesc(Iorig(:,:,1)),colormap(gray);truesize;
