function [lcx,lcy,rcx,rcy] = assignsnakes(BW,R,midx,midy)
% BW image containing two lungs
% R: radius of each snake
% midx,midy: a point on the image showing the
%            demarkation line of left-right lungs
%            as well as the at about the midpont of the chest

%figure(1),imagesc(BW), colormap(gray),drawnow;

[h,w]=size(BW);
se=strel('disk',2);
BW = imerode(imdilate(BW,se),se);
BW = xor(bwfill(BW,'holes'),BW);
[L,NUM] = bwlabel(BW);
stats = regionprops(L,'Area','Centroid');
AreaThreshold=400;
% the two big cc's closest to midx and midy
left=0; right=0; leftdist=max(h,w); rightdist=max(h,w);
for i=1:NUM,
    if stats(i).Area>AreaThreshold,
        cent = stats(i).Centroid;
        distan = sqrt((cent(1)-midx)^2 + (cent(2)-midy)^2);
        if cent(1)<=midx, % then this is the left lung
            if distan<leftdist,
                left=i;
                leftdist=distan;
            end
        else
            if distan<rightdist,
                right=i;
                rightdist=distan;
            end
        end
    end
end

se=strel('disk',2);
if left>0,
    Llung = imerode(L==left,se);
else
    Llung = BW; Llung(:)=0;
end
if right>0,
    Rlung = imerode(L==right,se);
else
    Rlung = BW; Rlung(:)=0;
end

% now assign snakes to left and right lungs
sh=2*R+5; sw=2*R+5;
SS = zeros(sh,sw);
SS(R+3,R+3)=1; Dt = bwdist(SS);
[indx,indy] = find(Dt<=R);
summax = sum(sum(double(Dt<=R)));

%t = 0:0.05:6.28;
lcx=[];lcy=[];rcx=[];rcy=[];
for i=sw:sw:w-2*sw,
    for j=sh:sh:h-2*sh,
        ind = h*(indx+i-2)+indy+j-1;
        if sum(double(Llung(ind)))==summax | sum(double(Rlung(ind)))==summax,
            if i+R+2<=midx
                lcx = [lcx;i+R+2]; lcy = [lcy;j+R+2];
            else
                rcx = [rcx;i+R+2]; rcy = [rcy;j+R+2];
            end
        end
        %snakedisp(i+R+2+R*cos(t),j+R+2+R*sin(t),'y'); drawnow;
    end
end